using System;
using System.Collections.Generic;

using Windows.ApplicationModel.DataTransfer;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// ҽ Ʈ
    /// </summary>
    private TreeView sourceTreeView;

    /// <summary>
    ///  Ʈ 
    /// </summary>
    private TreeViewNode deletedTreeViewNode;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.treeView1.DragItemsStarting  += TreeView_DragItemsStarting;
        this.treeView1.DragItemsCompleted += TreeView_DragItemsCompleted;
        this.treeView1.DragOver           += TreeView_DragOver;
        this.treeView1.Drop               += TreeView_Drop;

        this.treeView2.DragItemsStarting  += TreeView_DragItemsStarting;
        this.treeView2.DragItemsCompleted += TreeView_DragItemsCompleted;
        this.treeView2.DragOver           += TreeView_DragOver;
        this.treeView2.Drop               += TreeView_Drop;

        InitializeTreeView();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region Ʈ ׸ 巡 ۽ óϱ - TreeView_DragItemsStarting(sender, e)

    /// <summary>
    /// Ʈ ׸ 巡 ۽ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void TreeView_DragItemsStarting(TreeView sender, TreeViewDragItemsStartingEventArgs e)
    {
        if(e.Items.Count == 1)
        {
            e.Data.RequestedOperation = DataPackageOperation.Move;

            this.sourceTreeView = sender;

            foreach(object item in e.Items)
            {
                TreeViewNode treeViewNode = item as TreeViewNode;

                e.Data.SetText(treeViewNode.Content.ToString());
            }
        }
    }

    #endregion
    #region Ʈ ׸ 巡 Ϸ óϱ - TreeView_DragItemsCompleted(sender, e)

    /// <summary>
    /// Ʈ ׸ 巡 Ϸ óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void TreeView_DragItemsCompleted(TreeView sender, TreeViewDragItemsCompletedEventArgs e)
    {
        IList<TreeViewNode> childTreeViewNodeList = this.sourceTreeView.RootNodes[0].Children;

        if(this.deletedTreeViewNode != null)
        {
            for(int i = 0; i < childTreeViewNodeList.Count; i++)
            {
                if(childTreeViewNodeList[i].Content.ToString() == this.deletedTreeViewNode.Content.ToString())
                {
                    childTreeViewNodeList.RemoveAt(i);

                    break;
                }
            }
        }

        this.sourceTreeView      = null;
        this.deletedTreeViewNode = null;
    }

    #endregion
    #region Ʈ DRAG OVER óϱ - TreeView_DragOver(sender, e)

    /// <summary>
    /// Ʈ DRAG OVER óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private void TreeView_DragOver(object sender, DragEventArgs e)
    {
        if(e.DataView.Contains(StandardDataFormats.Text))
        {
            e.AcceptedOperation = DataPackageOperation.Move;
        }
    }

    #endregion
    #region Ʈ DROP óϱ - TreeView_Drop(sender, e)

    /// <summary>
    /// Ʈ DROP óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private async void TreeView_Drop(object sender, DragEventArgs e)
    {
        if(e.DataView.Contains(StandardDataFormats.Text))
        {
            string text = await e.DataView.GetTextAsync();

            TreeView targetTreeView = sender as TreeView;

            if(targetTreeView.RootNodes != null)
            {
                TreeViewNode newTreeViewNode = new TreeViewNode() { Content = text };

                targetTreeView.RootNodes[0].Children.Add(newTreeViewNode);

                this.deletedTreeViewNode = newTreeViewNode;
            }
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region Ʈ ʱȭϱ - InitializeTreeView()

    /// <summary>
    /// Ʈ ʱȭϱ
    /// </summary>
    private void InitializeTreeView()
    {
        TreeViewNode parentNode1 = new TreeViewNode() { Content = " 1" };

        parentNode1.IsExpanded = true;

        parentNode1.Children.Add(new TreeViewNode() { Content = " 1-1" });
        parentNode1.Children.Add(new TreeViewNode() { Content = " 1-2" });
        parentNode1.Children.Add(new TreeViewNode() { Content = " 1-3" });
        parentNode1.Children.Add(new TreeViewNode() { Content = " 1-4" });

        this.treeView1.RootNodes.Add(parentNode1);

        TreeViewNode parentNode2 = new TreeViewNode() { Content = " 2" };

        parentNode2.IsExpanded = true;

        parentNode2.Children.Add(new TreeViewNode() { Content = " 2-1" });
        parentNode2.Children.Add(new TreeViewNode() { Content = " 2-2" });

        this.treeView2.RootNodes.Add(parentNode2);
    }

    #endregion
}